from sqlalchemy import *
from migrate import *
import migrate.changeset
from dictionaries.versions import views_helper

def getIndices(meta):
    tmc1 = Table('tmc1', meta, autoload=True)
    tmc2 = Table('tmc2', meta, autoload=True)
    
    idxes = [
        Index('tmcgroupcode', tmc1.c.groupcode, unique=False),
        Index('tmcgroupcode', tmc2.c.groupcode, unique=False),
    ]
    return idxes

def upgrade(migrate_engine):
    meta = MetaData(bind=migrate_engine)
    # Upgrade operations go here. Don't create your own engine; use the engine
    # named 'migrate_engine' imported from migrate.
    for idx in getIndices(meta):
        idx.create()
    views_helper.update_dic_view(migrate_engine, 'tmc')

def downgrade(migrate_engine):
    meta = MetaData(bind=migrate_engine)
    # Operations to reverse the above upgrade go here.
    for idx in getIndices(meta):
        idx.drop()
    views_helper.update_dic_view(migrate_engine, 'tmc')
