from sqlalchemy import *
from migrate import *
import migrate.changeset
from dictionaries.versions import views_helper
import re

def getCardGroupTables(meta):
  cardgroup1 = Table('cardgroup1', meta, autoload=True)
  cardgroup2 = Table('cardgroup2', meta, autoload=True)
  return [cardgroup1,cardgroup2]

def upgrade(migrate_engine):
    # Upgrade operations go here. Don't create your own engine; use the engine
    # named 'migrate_engine' imported from migrate.
    meta = MetaData(bind = migrate_engine)
    for tbl in getCardGroupTables(meta):
        bonususecase = Column('bonususecase', Integer)
        if not 'bonususecase' in tbl.columns: 
            bonususecase.create(tbl)
    views_helper.update_dic_view(migrate_engine, 'cardgroup')
                                
                                
def downgrade(migrate_engine):
    # Operations to reverse the above upgrade go here.
    meta = MetaData(bind = migrate_engine)
    conn =migrate_engine.connect()
    tblname = views_helper.get_table_name(migrate_engine,'cardgroup')

    for tbl in getCardGroupTables(meta):
        if 'bonususecase' in tbl.columns: 
            tbl.c.bonususecase.drop()    

    views_helper.update_dic_view(migrate_engine, 'cardgroup',tblname)
