from sqlalchemy import *
from migrate import *
from dictionaries.versions import views_helper

def getCmactionTables(meta):
    cmaction1 = Table('cmaction1', meta, autoload=True)
    cmaction2 = Table('cmaction2', meta, autoload=True)
    return [cmaction1, cmaction2]

def upgrade(migrate_engine):
    meta = MetaData(bind = migrate_engine)
    for tbl in getCmactionTables(meta):
        if not 'notshowinservicemenu' in tbl.columns:
            notshowinservicemenu = Column('notshowinservicemenu', Integer, nullable=True)
            notshowinservicemenu.create(tbl)
    views_helper.update_dic_view(migrate_engine, 'cmaction')

def downgrade(migrate_engine):
    meta = MetaData(bind = migrate_engine)
    cmaction = views_helper.get_table_name(migrate_engine,'cmaction')
    for tbl in getCmactionTables(meta):
        if 'notshowinservicemenu' in tbl.columns:
            tbl.c.notshowinservicemenu.drop()
    views_helper.update_dic_view(migrate_engine, 'cmaction', cmaction)
