from sqlalchemy import *
from migrate import *
from dictionaries.versions import views_helper

def getTable(meta):
    return Table('alcoset', meta,
            Column('alcosetbarcode', String(100), nullable=False, primary_key=True),
            Column('code', String(100), nullable=False),
            Column('barcode', String(100), nullable=False, primary_key=True),
            Column('price',Numeric(precision=15,scale=2),nullable=False),
            Column('taracapacity',Numeric(precision=13,scale=3),nullable=True))

def upgrade(migrate_engine):
    meta = MetaData(bind=migrate_engine)
    views_helper.create_table(migrate_engine, getTable(meta))

def downgrade(migrate_engine):
    meta = MetaData(bind=migrate_engine)
    views_helper.drop_table(migrate_engine, getTable(meta))