from sqlalchemy import *
from migrate import *
from dictionaries.versions import views_helper


def getTmcAlcocodeTable(meta):
    return Table('tmcalcocode', meta,
        Column('tmccode', String(255), nullable=False),
        Column('alcocode', String(255), nullable=False, primary_key=True)
    )


def upgrade(migrate_engine):
    meta = MetaData(bind=migrate_engine)
    views_helper.create_table(migrate_engine, getTmcAlcocodeTable(meta))


def downgrade(migrate_engine):
    meta = MetaData(bind=migrate_engine)
    views_helper.drop_table(migrate_engine, getTmcAlcocodeTable(meta))

