from sqlalchemy import *
from migrate import *
from dictionaries.versions import views_helper


def getCatalogRestrictTable(meta):
    return Table('catalogrestrict', meta,
        Column('catalogid', Integer, nullable=True),
        Column('deptcode', Integer, nullable=True),
        Column('restrictid', Integer, nullable=False),
    )


def upgrade(migrate_engine):
    meta = MetaData(bind=migrate_engine)
    views_helper.create_table(migrate_engine, getCatalogRestrictTable(meta))


def downgrade(migrate_engine):
    meta = MetaData(bind=migrate_engine)
    views_helper.drop_table(migrate_engine, getCatalogRestrictTable(meta))
