from sqlalchemy import *
from migrate import *
import migrate.changeset

def getTables(meta):
    aspectitem = Table('aspectitem', meta,
        Column('aspectitemid', Integer, nullable=False, primary_key=True, autoincrement=True),
        Column('goodsitemid', Integer, ForeignKey('goodsitem.goodsitemid', name='aspectitemgoodsitemidfk'), nullable=False),
        Column('aspectcode', Integer, nullable=False),
        Column('aspectvaluecode', Integer, nullable=False),
        mysql_engine='InnoDB'
    )
    carditem = Table('carditem', meta,
        Column('carditemid', Integer, nullable=False, primary_key=True, autoincrement=True),
        Column('documentid', Integer, ForeignKey('document.documentid', name='carditemdocumentidfk'), nullable=False),
        Column('idcard', Integer, nullable=True),
        Column('idcardgroup', Integer, nullable=True),
        Column('idclient', Integer, nullable=True),
        Column('number', String(200), nullable=False),
        Column('validitydatebeg', Date(), nullable=True),
        Column('validitydateend', Date(), nullable=True),
        Column('cardSum', Numeric(precision=20, scale=2), nullable=True),
        Column('namecardgroup', String(200), nullable=True),
        Column('textcardgroup', String(200), nullable=True),
        Column('cardmode', Integer, nullable=True),
        Column('prefixbeg', String(200), nullable=True),
        Column('prefixend', String(200), nullable=True),
        Column('lenbeg', Integer, nullable=True),
        Column('lenend', Integer, nullable=True),
        Column('regexpattern', String(200), nullable=True),
        Column('inputmask', Integer, nullable=True),
        Column('regexrule', String(200), nullable=True),
        Column('valutcode', Integer, nullable=True),
        Column('discounttype', Integer, nullable=True),
        Column('discountvalue', Integer, nullable=True),
        Column('nameclient', String(200), nullable=True),
        Column('textclient', String(200), nullable=True),
        Column('sex', Integer, nullable=True),
        Column('birthday', Date(), nullable=True),
        Column('specialdate1', Date(), nullable=True),
        Column('specialdate2', Date(), nullable=True),
        Column('specialdate3', Date(), nullable=True),
        Column('specialdate1name', String(200), nullable=True),
        Column('specialdate2name', String(200), nullable=True),
        Column('specialdate3name', String(200), nullable=True),
        Column('zipcode', String(200), nullable=True),
        Column('address', String(200), nullable=True),
        Column('email', String(200), nullable=True),
        Column('webpage', String(200), nullable=True),
        Column('phonenumber', String(200), nullable=True),
        Column('inn', String(200), nullable=True),
        Column('document', String(200), nullable=True),
        Column('okpo', String(200), nullable=True),
        Column('okpd', String(200), nullable=True),
        Column('occupation', String(200), nullable=True),
        Column('childrencount', Integer, nullable=True),
        Column('extendedoptions', Text(), nullable=True),
        Column('itemtime', DateTime, nullable=True),
        Column('itemorder', Integer, nullable=True),
        Column('inputsource', Integer, nullable=True),
        mysql_engine='InnoDB'
    )
    crights = Table('crights', meta,
        Column('crightsid', Integer, nullable=False, primary_key=True, autoincrement=True),
        Column('workshiftid', Integer, ForeignKey('workshift.workshiftid', name='crightsworkshiftidfk'), nullable=True),
        Column('cashiercard', String(30), nullable=True),
        Column('cashiername', String(100), nullable=True),
        Column('actorcard', String(30), nullable=True),
        Column('actorname', String(100), nullable=True),
        Column('op', String(200), nullable=True),
        Column('isgoodsitem', Integer, nullable=True),
        Column('optime', DateTime, nullable=True),
        Column('opcode', Integer, nullable=True),
        mysql_engine='InnoDB'
    )
    discitem = Table('discitem', meta,
        Column('discitemid', Integer, nullable=False, primary_key=True, autoincrement=True),
        Column('goodsitemid', Integer, ForeignKey('goodsitem.goodsitemid', name='discitemgoodsitemidfk'), nullable=True),
        Column('positionnum', Integer, nullable=False),
        Column('scode', String(30), nullable=False),
        Column('dtime', DateTime, nullable=False),
        Column('ispositiondiscount', Integer, nullable=False),
        Column('discnumber', Integer, nullable=False),
        Column('discmode', Integer, nullable=False),
        Column('disctype', Integer, nullable=False),
        Column('discsize', Numeric(precision=13, scale=2), nullable=False),
        Column('discsum', Numeric(precision=13, scale=2), nullable=False),
        Column('discname', String(200), nullable=False),
        Column('disccode', Integer, nullable=False),
        Column('discscheme', Integer, nullable=False),
        Column('checksum', Numeric(precision=13, scale=2), nullable=False),
        Column('accumulatesum', Numeric(precision=13, scale=2), nullable=False),
        Column('cardnumber', String(200), nullable=True),
        Column('cardname', String(100), nullable=True),
        Column('cardtype', Integer, nullable=False),
        mysql_engine='InnoDB'
    )
    document = Table('document', meta,
        Column('documentid', Integer, nullable=False, primary_key=True, autoincrement=True),
        Column('workshiftid', Integer, ForeignKey('workshift.workshiftid', name='documentworkshiftidfk'), nullable=False),
        Column('checknum', Integer, nullable=False),
        Column('doctype', Integer, nullable=False),
        Column('dept', Integer, nullable=False),
        Column('scode', String(30), nullable=False),
        Column('time_beg', DateTime, nullable=False),
        Column('time_end', DateTime, nullable=True),
        Column('vbrate', Numeric(precision=13, scale=4), nullable=False),
        Column('verate', Numeric(precision=13, scale=4), nullable=False),
        Column('sum1', Numeric(precision=13, scale=2), nullable=False),
        Column('sum2', Numeric(precision=13, scale=2), nullable=False),
        Column('sum2m', Numeric(precision=13, scale=2), nullable=False),
        Column('summode', Integer, nullable=False),
        Column('sumtype', Integer, nullable=False),
        Column('disc_perc', Numeric(precision=5, scale=2), nullable=False),
        Column('disc_abs', Numeric(precision=13, scale=2), nullable=False),
        Column('sumb', Numeric(precision=13, scale=2), nullable=False),
        Column('sumn', Numeric(precision=13, scale=2), nullable=False),
        Column('sume', Numeric(precision=13, scale=2), nullable=False),
        Column('vatsum', Numeric(precision=13, scale=2), nullable=False),
        Column('docnum', String(32), nullable=False),
        Column('c_link', Integer, nullable=False),
        Column('closed', Integer, nullable=False),
        Column('opid', Integer, nullable=True),
        mysql_engine='InnoDB'
    )
    goodsitem = Table('goodsitem', meta,
        Column('goodsitemid', Integer, nullable=False, primary_key=True, autoincrement=True),
        Column('documentid', Integer, ForeignKey('document.documentid', name='goodsitemdocumentidfk'), nullable=False),
        Column('deptcode', Integer, nullable=False),
        Column('scode', String(30), nullable=False),
        Column('ttime', DateTime, nullable=False),
        Column('opcode', Integer, nullable=False),
        Column('status', Integer, nullable=False),
        Column('bcode', String(100), nullable=False),
        Column('name', String(200), nullable=False),
        Column('articul', String(100), nullable=False),
        Column('measure', Integer, nullable=False),
        Column('bcode_mode', Integer, nullable=False),
        Column('bcode_main', String(100), nullable=False),
        Column('bquant', Numeric(precision=13, scale=3), nullable=False),
        Column('bquant_mode', Integer, nullable=False),
        Column('ost_modif', Integer, nullable=False),
        Column('cquant', Numeric(precision=13, scale=3), nullable=False),
        Column('pricetype', Integer, nullable=False),
        Column('pricevcode', Integer, nullable=False),
        Column('price', Numeric(precision=13, scale=2), nullable=False),
        Column('minprice', Numeric(precision=13, scale=2), nullable=False),
        Column('pricei', Numeric(precision=13, scale=2), nullable=False),
        Column('price_mode', Integer, nullable=False),
        Column('tindex', Integer, nullable=False),
        Column('disc_perc', Numeric(precision=5, scale=2), nullable=False),
        Column('disc_abs', Numeric(precision=13, scale=2), nullable=False),
        Column('sumi', Numeric(precision=13, scale=2), nullable=False),
        Column('sumb', Numeric(precision=13, scale=2), nullable=False),
        Column('sumn', Numeric(precision=13, scale=2), nullable=False),
        Column('sume', Numeric(precision=13, scale=2), nullable=False),
        Column('vatcode1', Integer, nullable=False),
        Column('vatrate1', Numeric(precision=5, scale=2), nullable=False),
        Column('vatsum1', Numeric(precision=13, scale=2), nullable=False),
        Column('vatcode2', Integer, nullable=False),
        Column('vatrate2', Numeric(precision=5, scale=2), nullable=False),
        Column('vatsum2', Numeric(precision=13, scale=2), nullable=False),
        Column('vatcode3', Integer, nullable=False),
        Column('vatrate3', Numeric(precision=5, scale=2), nullable=False),
        Column('vatsum3', Numeric(precision=13, scale=2), nullable=False),
        Column('vatcode4', Integer, nullable=False),
        Column('vatrate4', Numeric(precision=5, scale=2), nullable=False),
        Column('vatsum4', Numeric(precision=13, scale=2), nullable=False),
        Column('vatcode5', Integer, nullable=False),
        Column('vatrate5', Numeric(precision=5, scale=2), nullable=False),
        Column('vatsum5', Numeric(precision=13, scale=2), nullable=False),
        Column('docnum', String(32), nullable=False),
        Column('c_link', Integer, nullable=False),
        Column('code', String(100), nullable=False),
        Column('posnum', Integer, nullable=False),
        Column('frnum', Integer, nullable=False),
        Column('extendetoptions', String(8000), nullable=True),
        Column('opid', Integer, nullable=True),
        mysql_engine='InnoDB'
    )
    moneyitem = Table('moneyitem', meta,
        Column('moneyitemid', Integer, nullable=False, primary_key=True, autoincrement=True),
        Column('documentid', Integer, ForeignKey('document.documentid', name='moneyitemdocumentidfk'), nullable=False),
        Column('acode', String(30), nullable=False),
        Column('scode', String(30), nullable=False),
        Column('mtime', DateTime, nullable=False),
        Column('opcode', Integer, nullable=False),
        Column('valcode', Integer, nullable=False),
        Column('nrate', Numeric(precision=13, scale=4), nullable=False),
        Column('bond', Numeric(precision=13, scale=4), nullable=False),
        Column('bond_quant', Integer, nullable=False),
        Column('vsum', Numeric(precision=13, scale=2), nullable=False),
        Column('sumb', Numeric(precision=13, scale=2), nullable=False),
        Column('sumn', Numeric(precision=13, scale=2), nullable=False),
        Column('sume', Numeric(precision=13, scale=2), nullable=False),
        Column('docnum', String(32), nullable=False),
        Column('c_link', Integer, nullable=False),
        Column('frnum', Integer, nullable=False),
        Column('cardnum', String(100), nullable=False),
        mysql_engine='InnoDB'
    )
    stornogoodsitem = Table('stornogoodsitem', meta,
        Column('stornogoodsitemid', Integer, nullable=False, primary_key=True, autoincrement=True),
        Column('documentid', Integer, ForeignKey('document.documentid', name='stornogoodsitemdocumentidfk'), nullable=False),
        Column('deptcode', Integer, nullable=False),
        Column('scode', String(30), nullable=False),
        Column('tstime', DateTime, nullable=False),
        Column('timestorno', DateTime, nullable=False),
        Column('opcode', Integer, nullable=False),
        Column('status', Integer, nullable=False),
        Column('bcode', String(100), nullable=False),
        Column('name', String(200), nullable=False),
        Column('articul', String(100), nullable=False),
        Column('measure', Integer, nullable=False),
        Column('bcode_mode', Integer, nullable=False),
        Column('bcode_main', String(100), nullable=False),
        Column('bquant', Numeric(precision=13, scale=3), nullable=False),
        Column('bquant_mode', Integer, nullable=False),
        Column('ost_modif', Integer, nullable=False),
        Column('cquant', Numeric(precision=13, scale=3), nullable=False),
        Column('pricetype', Integer, nullable=False),
        Column('pricevcode', Integer, nullable=False),
        Column('price', Numeric(precision=13, scale=2), nullable=False),
        Column('minprice', Numeric(precision=13, scale=2), nullable=False),
        Column('pricei', Numeric(precision=13, scale=2), nullable=False),
        Column('price_mode', Integer, nullable=False),
        Column('tsindex', Integer, nullable=False),
        Column('disc_perc', Numeric(precision=5, scale=2), nullable=False),
        Column('disc_abs', Numeric(precision=13, scale=2), nullable=False),
        Column('sumi', Numeric(precision=13, scale=2), nullable=False),
        Column('sumb', Numeric(precision=13, scale=2), nullable=False),
        Column('sumn', Numeric(precision=13, scale=2), nullable=False),
        Column('sume', Numeric(precision=13, scale=2), nullable=False),
        Column('vatcode1', Integer, nullable=False),
        Column('vatrate1', Numeric(precision=5, scale=2), nullable=False),
        Column('vatsum1', Numeric(precision=13, scale=2), nullable=False),
        Column('vatcode2', Integer, nullable=False),
        Column('vatrate2', Numeric(precision=5, scale=2), nullable=False),
        Column('vatsum2', Numeric(precision=13, scale=2), nullable=False),
        Column('vatcode3', Integer, nullable=False),
        Column('vatrate3', Numeric(precision=5, scale=2), nullable=False),
        Column('vatsum3', Numeric(precision=13, scale=2), nullable=False),
        Column('vatcode4', Integer, nullable=False),
        Column('vatrate4', Numeric(precision=5, scale=2), nullable=False),
        Column('vatsum4', Numeric(precision=13, scale=2), nullable=False),
        Column('vatcode5', Integer, nullable=False),
        Column('vatrate5', Numeric(precision=5, scale=2), nullable=False),
        Column('vatsum5', Numeric(precision=13, scale=2), nullable=False),
        Column('docnum', String(32), nullable=False),
        Column('c_link', Integer, nullable=False),
        Column('code', String(100), nullable=False),
        Column('posnum', Integer, nullable=False),
        Column('frnum', Integer, nullable=False),
        Column('opid', Integer, nullable=True),
        Column('extendetoptions', String(8000), nullable=True),
        mysql_engine='InnoDB'
    )
    workshift = Table('workshift', meta,
        Column('workshiftid', Integer, nullable=False, primary_key=True, autoincrement=True),
        Column('shiftnum', Integer, nullable=False),
        Column('cashcode', String(30), nullable=False),
        Column('scode', String(30), nullable=True),
        Column('time_beg', DateTime, nullable=True),
        Column('time_end', DateTime, nullable=True),
        Column('checknum1', Integer, nullable=False),
        Column('checknum2', Integer, nullable=False),
        Column('vb', Integer, nullable=False),
        Column('vn', Integer, nullable=False),
        Column('ve', Integer, nullable=False),
        Column('mode1', Integer, nullable=False),
        Column('mode2', Integer, nullable=False),
        Column('arcpath', String(64), nullable=True),
        mysql_engine='InnoDB'
    )

    return [ workshift, document, goodsitem, aspectitem, carditem, discitem, moneyitem, stornogoodsitem, crights ]

def upgrade(migrate_engine):
    meta = MetaData(bind = migrate_engine)
    # Upgrade operations go here. Don't create your own engine; use the engine
    # named 'migrate_engine' imported from migrate.
    for table in getTables(meta):
        table.create()

def downgrade(migrate_engine):
    meta = MetaData(bind = migrate_engine)
    # Operations to reverse the above upgrade go here.
    for table in reversed(getTables(meta)):
        table.drop()
