# -*- coding: utf-8 -*-
from sqlalchemy import *
from migrate import *
import migrate.changeset

def getKKMTable(meta):
    return Table('kkm', meta, autoload=True)

def getShiftTable(meta):
    return Table('workshift', meta, autoload=True)

def upgrade(migrate_engine):
    meta = MetaData(bind=migrate_engine)
# dropping old foreign keys
    for keyName in ['kkmworkshiftidfk_1','kkmworkshiftidfk']:
        if keyName in [key.name for key in getKKMTable(meta).foreign_keys]:
            changeset.constraint.ForeignKeyConstraint([getKKMTable(meta).c.workshiftid], [getShiftTable(meta).c.workshiftid],
                                 name=keyName).drop()
            changeset.constraint.ForeignKeyConstraint([getKKMTable(meta).c.workshiftid], [getShiftTable(meta).c.workshiftid], name=keyName,
                                 ondelete='CASCADE').create()


def downgrade(migrate_engine):
    pass

